function RR_Test()
	ChatFrame1:AddMessage("Kilerpet's Raid Roll Addon - Loaded")
end

function RaidRoll_OnLoad()

 SLASH_RR1 = "/rr";
 SLASH_RR2 = "/raidroll";
 
 SlashCmdList["RR"] =  RR_Command;
 
 RR_Test()
 
  this:RegisterEvent("CHAT_MSG_SYSTEM")
  
  RR_Has_Rolled = false
end


function RaidRoll_Event()
--ChatFrame1:AddMessage(arg1)

if RR_Has_Rolled == true then
	
	--Wait for the player to roll
	null,roll_loc = string.find(arg1, UnitName("player") .. " rolls");

	--Find where in the roll the number is
	if roll_loc ~= nil then
		my_roll = strsub(arg1,roll_loc+2,roll_loc+3)
	end
	
	--Convert it from a string to a number
	my_roll = tonumber(my_roll)

	if GetRaidRosterInfo(my_roll) ~= nil and roll_loc ~= nil and RR_ItemLink == nil then
		SendChatMessage(">>> " .. RR_Name_Array[my_roll] .. " Wins! <<<", "RAID")
	end
	
	if GetRaidRosterInfo(my_roll) ~= nil and roll_loc ~= nil and RR_ItemLink ~= nil then
		SendChatMessage(">>> " .. RR_Name_Array[my_roll] .. " Wins " .. RR_ItemLink .. "! <<<", "RAID")
	end
	
	RR_Has_Rolled  = false
end


end

function RR_Command(cmd)
--Stuff that happens when you press /mm <command>

RR_ItemLink = nil --clearing the variable


cmd_n = tonumber(cmd)

--Do a standard Raid roll
	if cmd_n ~= nil or cmd == "" then 
		if GetNumRaidMembers() ~= 0 then
			if cmd == "" then
				RR_DoARaidRoll(GetNumRaidMembers())
			end
			
			if type(cmd_n) == "number" then
				if cmd_n > GetNumRaidMembers() then
					cmd_n = GetNumRaidMembers();
				end
				
				--ChatFrame1:AddMessage(cmd_n)
				RR_DoARaidRoll(cmd_n)
			end
			
			--ChatFrame1:AddMessage(type(cmd_n))
		else
			ChatFrame1:AddMessage("You are not in a raid group")
		end
	end

	
cmd_s = string.lower(cmd)
	
	if cmd_s == "test" then
		 RR_Test()
	end	
	
	--[[if cmd_s == "re" or cmd_s == "reroll" then
		if RR_num ~= nil then
			RR_Roll()
		else
			RR_DoARaidRoll(GetNumRaidMembers())
		end
	end	]]--
	
--Find the start and end location of the item link
	RR_Start_Loc,_ = string.find(cmd, "item:");
	_,RR_End_Loc = string.find(cmd, "|h|r")
	
--Cut the itemlink out of the string
	if RR_Start_Loc ~= nil and RR_End_Loc ~= nil then
		RR_ItemLink = strsub(cmd,RR_Start_Loc-12,RR_End_Loc)
	end
--For debugging, show the itemlink
	--ChatFrame1:AddMessage(RR_ItemLink)

--Cut up the command to see if it was a reroll or not
	RR_Reroll = strsub(cmd_s,1,2)
	RR_Reroll_Long = strsub(cmd_s,1,6)
	
--for debugging, show the results of the split up string
	--ChatFrame1:AddMessage(RR_Reroll)
	--ChatFrame1:AddMessage(RR_Reroll_Long)
	

	if RR_Reroll == "re" or RR_Reroll_Long == "reroll" then
		if RR_num ~= nil then
			if RR_ItemLink ~= nil then
				SendChatMessage("<<Raid Rolling for: ".. RR_ItemLink .. " >>" , "RAID_WARNING")
			end
			
			RR_Roll()
		else
			RR_DoARaidRoll(GetNumRaidMembers())
		end
	end
	
	if strsub(cmd,1,1) == "|" then
		RR_DoARaidRoll(GetNumRaidMembers())
	end
	
	
end

function RR_DoARaidRoll(num)

	RR_num = num
	
	RR_Name_Array = {}
	
	if RR_ItemLink == nil then
		SendChatMessage("<<Raid Rolling>> (ID - Name)" , "RAID")
	end
	
	if RR_ItemLink ~= nil then
		SendChatMessage("<<Raid Rolling for: " .. RR_ItemLink .. " >> (ID - Name)" , "RAID_WARNING")
	end
	
	for i=1,num do
		RR_Name_Array[i] = GetRaidRosterInfo(i)
		--SendChatMessage(RR_Name_Array[i], "RAID")
	end
		
	if num < 21 then 
		num = num + 1
		for i=1,num/2 do
			i_mod = 2 * i
			--ChatFrame1:AddMessage(i_mod .. num)
			if GetRaidRosterInfo(i_mod) ~= nil and i_mod <= num-1 then 
				SendChatMessage("#".. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1) .. "" .. "    #" .. i_mod .." - " .. GetRaidRosterInfo(i_mod), "RAID")
			else
				SendChatMessage("#".. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1), "RAID")
			end
			--ChatFrame1:AddMessage("#".. i .." - " .. GetRaidRosterInfo(i))
			--ChatFrame1:AddMessage(num)				
		end
	else
		num = num + 2
		for i=1,num/3 do
			i_mod = 3 * i
			--ChatFrame1:AddMessage(i_mod .. num)
			if GetRaidRosterInfo(i_mod) ~= nil and i_mod <= num-2 then 
				SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2) .. "    #" .. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1) .. "    #" .. i_mod .." - " .. GetRaidRosterInfo(i_mod), "RAID")
			elseif GetRaidRosterInfo(i_mod-1) ~= nil and  i_mod <= num-1 then
				SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2) .. "" .. "    #" .. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1), "RAID")
			else
				SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2), "RAID")
			end
			--ChatFrame1:AddMessage("#".. i .." - " .. GetRaidRosterInfo(i))
			--ChatFrame1:AddMessage(num)				
		end
	end
	
	if not _Y then 
		UIParent:HookScript("OnUpdate",function() if _Y>0 and GetTime()>=_Y then _Y=0 RR_Roll(); end end)
	end 
	_Y=GetTime()+2
	
end

function RR_Roll()

RandomRoll(1,RR_num);

RR_Has_Rolled = true

end

